package com.vendor.burn.commands;

package .var.folders.cl.9twcgjfx4vsg5zl73c6wxmvm0000gn.T;

import com.vendor.burn.commands.SerialCommand;
import com.vendor.burn.model.FlashType;

public class ReadCommand extends SerialCommand {
  private static final String KEY_READ = "read";
  
  private static final String KEY_READ_YAFFS = "read.yaffs";
  
  private ReadCommand(String command, String length) {
    super(command);
    setTimeout(calculateTimeOut(length));
  }
  
  public static com.vendor.burn.commands.ReadCommand read(FlashType flashType, String destination, String original, String length) {
    return read(flashType, "read", destination, original, length);
  }
  
  public static com.vendor.burn.commands.ReadCommand readYaffs(FlashType flashType, String destination, String original, String length) {
    return read(flashType, "read.yaffs", destination, original, length);
  }
  
  public static com.vendor.burn.commands.ReadCommand readMMC_0_Destination_(String destination, String original, String length, FlashType flashType) {
    StringBuilder sb = new StringBuilder();
    if (FlashType.fuzzyCompareFlash(flashType, FlashType.ufs)) {
      sb.append("ufs").append(" ").append("read").append(" ").append("0")
        .append(" ");
    } else if (flashType == FlashType.ssd) {
      sb.append("nvme").append(" ").append("read").append(" ");
    } else {
      sb.append("mmc").append(" ").append("read").append(" ").append("0")
        .append(" ");
    } 
    if (!destination.startsWith("0x"))
      sb.append("0x"); 
    sb.append(destination).append(" ");
    if (!original.startsWith("0x"))
      sb.append("0x"); 
    sb.append(original).append(" ");
    if (!length.startsWith("0x"))
      sb.append("0x"); 
    sb.append(length);
    com.vendor.burn.commands.ReadCommand readCommand = new com.vendor.burn.commands.ReadCommand(sb.toString(), length);
    return readCommand;
  }
  
  private static com.vendor.burn.commands.ReadCommand read(FlashType flashType, String KEY, String destination, String original, String length) {
    StringBuilder sb = new StringBuilder();
    if (flashType == FlashType.spi) {
      sb.append("sf");
    } else {
      sb.append(flashType.name());
    } 
    sb.append(" ").append(KEY).append(" ");
    if (!destination.startsWith("0x"))
      sb.append("0x"); 
    sb.append(destination).append(" ");
    if (!original.startsWith("0x"))
      sb.append("0x"); 
    sb.append(original).append(" ");
    if (!length.startsWith("0x"))
      sb.append("0x"); 
    sb.append(length);
    return new com.vendor.burn.commands.ReadCommand(sb.toString(), length);
  }
}
